/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// OnCallPlayDone - Invoked when a play command is completed.    OnCallRecordDone - Invoked when a record command is completed.
    /// </summary>
    [DataContract]
        public partial class BridgesSubscriptions :  IEquatable<BridgesSubscriptions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BridgesSubscriptions" /> class.
        /// </summary>
        /// <param name="onBridgePlayDone">onBridgePlayDone.</param>
        /// <param name="onBridgeRecordDone">onBridgeRecordDone.</param>
        public BridgesSubscriptions(string onBridgePlayDone = default(string), string onBridgeRecordDone = default(string))
        {
            this.OnBridgePlayDone = onBridgePlayDone;
            this.OnBridgeRecordDone = onBridgeRecordDone;
        }
        
        /// <summary>
        /// Gets or Sets OnBridgePlayDone
        /// </summary>
        [DataMember(Name="onBridgePlayDone", EmitDefaultValue=false)]
        public string OnBridgePlayDone { get; set; }

        /// <summary>
        /// Gets or Sets OnBridgeRecordDone
        /// </summary>
        [DataMember(Name="onBridgeRecordDone", EmitDefaultValue=false)]
        public string OnBridgeRecordDone { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BridgesSubscriptions {\n");
            sb.Append("  OnBridgePlayDone: ").Append(OnBridgePlayDone).Append("\n");
            sb.Append("  OnBridgeRecordDone: ").Append(OnBridgeRecordDone).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BridgesSubscriptions);
        }

        /// <summary>
        /// Returns true if BridgesSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of BridgesSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BridgesSubscriptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnBridgePlayDone == input.OnBridgePlayDone ||
                    (this.OnBridgePlayDone != null &&
                    this.OnBridgePlayDone.Equals(input.OnBridgePlayDone))
                ) && 
                (
                    this.OnBridgeRecordDone == input.OnBridgeRecordDone ||
                    (this.OnBridgeRecordDone != null &&
                    this.OnBridgeRecordDone.Equals(input.OnBridgeRecordDone))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnBridgePlayDone != null)
                    hashCode = hashCode * 59 + this.OnBridgePlayDone.GetHashCode();
                if (this.OnBridgeRecordDone != null)
                    hashCode = hashCode * 59 + this.OnBridgeRecordDone.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
